unit gridfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_vgcore, dx_scene, dx_vglayer, ImgList;

type
  TForm10 = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    ObjectLayer1: TdxObjectLayer;
    Root2: TvxLayout;
    Grid1: TvxGrid;
    Column1: TvxColumn;
    CheckColumn1: TvxCheckColumn;
    ProgressColumn1: TvxProgressColumn;
    Column2: TvxColumn;
    PopupColumn1: TvxPopupColumn;
    ImageColumn1: TvxImageColumn;
    vxImageList1: TvxImageList;
    procedure Grid1GetValue(Sender: TObject; const Col, Row: Integer;
      var Value: Variant);
    procedure Grid1SetValue(Sender: TObject; const Col, Row: Integer;
      const Value: Variant);
  private
    Data: array of array of Variant;
    procedure CreateData;
  public
    { Public declarations }
  end;

var
  Form10: TForm10;

implementation

{$R *.dfm}

procedure TForm10.CreateData;
var
  i: integer;

begin
  // set table row count
  Grid1.RowCount := 300;
  // set column Tag - this is real index - because Column may realign
  for i := 0 to Grid1.ColumnCount - 1 do
    Grid1.Columns[i].Tag := i;
  // create array
  SetLength(Data, Grid1.ColumnCount);
  for i := 0 to High(Data) do
  begin
    SetLength(Data[i], Grid1.RowCount);
  end;
  // Initialize Data
  // 0 Column - text
  for i := 0 to Grid1.RowCount - 1 do
    Data[0][i] := 'text cell ' + IntToStr(i);
  // 1 Column - check
  for i := 0 to Grid1.RowCount - 1 do
    Data[1][i] := random(3) = 2;
  // 2 Column - progress
  for i := 0 to Grid1.RowCount - 1 do
    Data[2][i] := random(100);
  // 3 Column - text
  for i := 0 to Grid1.RowCount - 1 do
    Data[3][i] := 'second text ' + IntToStr(i);
  // 4 Column - popup
  for i := 0 to Grid1.RowCount - 1 do
    Data[4][i] := PopupColumn1.Items[random(PopupColumn1.Items.Count)];
  // 5 Column - image
  for i := 0 to Grid1.RowCount - 1 do
    Data[5][i] := ObjectToVariant(vxImageList1.Images[random(vxImageList1.Count)]);
end;

procedure TForm10.Grid1GetValue(Sender: TObject; const Col, Row: Integer;
  var Value: Variant);
begin
  if Length(Data) = 0 then
  begin
    // Init Data arrays
    CreateData;
  end;
  // we not use Col - because Col return Column - but Column may realigned
  Value := Data[Grid1.Columns[Col].Tag][Row];
end;

procedure TForm10.Grid1SetValue(Sender: TObject; const Col, Row: Integer;
  const Value: Variant);
begin
  // we not use Col - because Col return Column - but Column may realigned
  Data[Grid1.Columns[Col].Tag][Row] := Value;
end;

end.
